/*  㠫쭮   C++.
   ࣥ ਭ.
*/

# ifndef __vp_h
# define __vp_h

typedef unsigned char Byte;
const   int           StackSize = 16;

class EVP { };
class EVP_BadCode:        public EVP { };
class EVP_BadPC:          public EVP { };
class EVP_BadCommand:     public EVP { };
class EVP_StackOverflow:  public EVP { };
class EVP_StackUnderflow: public EVP { };
class EVP_File:           public EVP { };
class EVP_FileNotOpen:    public EVP_File { };
class EVP_BadFile:        public EVP_File { };
class EVP_FileError:      public EVP_File { };

class TVirtualProcessor
{ private:
    Byte* Code;
    int   CodeSize;
    int   PC;
    int   SP;
    int   Stack[StackSize];
    bool  FromFile;
    bool  Active;

    void  Init();

  protected:
    int  SubCommand;
    int  BasePriority;
    int  CurrentPriority;

    Byte GetCommand()  throw(EVP_BadCode, EVP_BadPC);
    Byte GetByte()     { return Code[PC++]; }
    int  GetInt()      throw();
    long GetLong()     throw();
    void GoTo(int aPC) throw(EVP_BadPC);
    void Call(int aPC) throw(EVP_StackOverflow, EVP_BadPC);
    void Return()      throw(EVP_StackUnderflow);

    void RemoteCommand();
    virtual void TransferCommand(int aAddress, void* aData, int aSize);

  public:
    TVirtualProcessor(const Byte* aCode, int aCodeSize);
    TVirtualProcessor(const char* aFile);
    ~TVirtualProcessor();

    void Start()                    { Active = true;            }
    void Stop()                     { Active = false;           }
    void SetPriority(int aPriority) { BasePriority = aPriority; }

    bool Ready()     const          { return Active;            }
    int  Priority()  const          { return BasePriority;      }

    virtual bool Step() = 0;
    virtual bool RemoteStep();
    virtual void Execute();
};

# endif
